/*
 * Copyright 2013 (c) Anna Schumaker.
 */
#ifndef OCARINA_PLAYLIST_H
#define OCARINA_PLAYLIST_H

#include <file.h>
#include <vector>

enum playlist_flags {
	PL_ENABLED	= (1 << 0),
	PL_RANDOM	= (1 << 1),
	PL_LOCKED	= (1 << 2),
};

class Playlist {
private:
	std :: vector <unsigned int> tracks;
	unsigned int flags;
	unsigned int cur;

public:
	Playlist();
	Playlist(playlist_flags);
	~Playlist();
	void write(File &);
	void read(File &);

	void set_flag(playlist_flags);
	void unset_flag(playlist_flags);
	const unsigned int get_flags();

	unsigned int add(unsigned int);
	void del(unsigned int);
	unsigned int size();

	unsigned int next();
};

#endif /* OCARINA_PLAYLIST_H */
